#include <stdio.h>
#include <unistd.h>
#include <linux/input.h>

#include "lircd.h"

int lastvalue,lastcount;
int paused=0;
char messagebuf[128];

char *keys[256] = {
/*00*/  "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "",
/*10*/  "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "",
/*20*/  "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "",
/*30*/  "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "",
/*40*/  "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "",
/*50*/  "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "",
/*60*/  "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "",
/*70*/  "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "",
/*80*/  "", "", "vol+", "green", "goto", "exit", "right", "eject", "ffwd", "", "", "", "left", "", "kleft", "play",
/*90*/  "power", "blue", "", "left", "down", "jump+", "scr+", "", "", "right", "", "", "", "", "ch-", "ch+",
/*A0*/  "", "up", "jump-", "rec", "power", "", "", "", "ok", "", "", "clear", "scr-", "", "menu", "home",
/*B0*/  "mute", "info", "down", "", "", "", "", "", "", "yellow", "", "5", "6", "4", "", "3",
/*C0*/  "", "2", "0", "1", "9", "", "", "", "", "", "", "", "", "", "", "",
/*D0*/  "", "", "", "", "", "dup", "ddown", "", "7", "stop", "vol-", "", "", "", "", "",
/*E0*/  "", "", "", "", "8", "", "", "red", "keyb", "ok", "frew", "", "", "up", "", "",
/*F0*/  "", "", "", "", "", "cancel", "option", "dleft", "dright", "tv", "", "", "", "kright", "enter", ""
};

char *getKey(int efd)
{
   struct input_event ev[64];
   int rd, value, size = sizeof (struct input_event);

   if((rd = read (efd, ev, size * 64)) < size)
      return NULL;

   value = ev[0].value;
//   printf ("raw 0x0%04x \n", value);
//   printf("%d-%d\n", ev[1].value,ev[1].type);
   if(value != ' ' && ev[1].value >= 1 && ev[1].type == 1) {
//      printf ("val 0x0%04x \n", value);
      if(value == 0x3c) {
         //printf("ALT\n");

         if(lastvalue == 0x3c) {
            sprintf(messagebuf,"000000000000%04x %02i %s ZENEGA\n"
                    ,value,lastcount,keys[value]);
            lastvalue = 0;
            return messagebuf;
         }
         else {
            lastvalue = value;
            return NULL;
         }

      }
      else if(keys[value] != NULL) {
         //printf ("%s\n", (keys[value]));
         /*
         if (lastvalue == value)
                 lastcount++;
         else
                 lastcount=0;
         */
         lastcount=0;

         if(lastvalue == 0x3c) {
            sprintf(messagebuf,"000000000000%04x %02i ALT-%s ACTIVY\n"
                    ,value,lastcount,keys[value]);
         }
         else if( lastvalue == 0x8f && value == 0x8f) {
            sprintf(messagebuf,"000000000000%04x %02i pause ACTIVY\n"
                    ,value,lastcount);
            value = 0x13e;
         }
         else {
            sprintf(messagebuf,"000000000000%04x %02i %s ACTIVY\n"
                    ,value,lastcount,keys[value]);
         }


         lastvalue = value;
         return messagebuf;
      }
      else {
         return "unknown";
      }
   }
   printf("Exit\n");
   return NULL;
}
